package com.blogspot.revbingo.threed;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;

public class InfoPanel {

	private String currentState;
	private String lightPosition;
	private String lightDirection;
	private double fps;
	private int polyCount;
	private int currentLight;
	
	private AffineTransform identity = new AffineTransform(1,0,0,1,0,0);
	private Font hudFont = new Font("Consolas", Font.PLAIN, 8);
	
	public String getCurrentState() {
		return currentState;
	}
	public void setCurrentState(String currentState) {
		this.currentState = currentState;
	}
	public String getLightPosition() {
		return lightPosition;
	}
	public void setLightPosition(String lightPosition) {
		this.lightPosition = lightPosition;
	}
	public String getLightDirection() {
		return lightDirection;
	}
	public void setLightDirection(String lightDirection) {
		this.lightDirection = lightDirection;
	}
	public double getFps() {
		return fps;
	}
	public void setFps(double fps) {
		this.fps = fps;
	}
	
	public void draw(Graphics2D g2) {
		g2.setTransform(identity);
		g2.setColor(Color.GREEN);
		g2.setFont(hudFont);
		int yIndex = 1;
		int yGap = 10;
		g2.drawString("State: " + currentState, 10, yIndex++ * yGap);
		g2.drawString("Light: " + currentLight, 10, yIndex++ * yGap);
		g2.drawString("Light pos: " + lightPosition, 10, yIndex++ * yGap);
		g2.drawString("Points at: " + lightDirection, 10, yIndex++ * yGap);
		g2.drawString("FPS: " + fps, 10, yIndex++ * yGap);
		g2.drawString("Polys: " + polyCount, 10, yIndex++ * yGap);
	}
	
	public void setPolyCount(int i) {
		this.polyCount = i;
	}
	public void setCurrentLight(int lightIndex) {
		currentLight = lightIndex;
	}
	
}
