package com.blogspot.revbingo.threed;

import java.awt.Color;

import com.blogspot.revbingo.threed.lights.LightScene;

public abstract class Primitive extends SceneObject implements Lightable, Comparable<Primitive> {

	public abstract double getZOrder();
	public abstract void translate(double dx, double dy, double dz);
	public abstract boolean canBeCulled();
	public abstract void lightPolygon(LightScene lights);
	public abstract void project(TransformMatrix tm);
	
	public abstract Vector getNormal();
	public abstract void setSurfaceColor(Color c);
	/** 
	 * Implementing compareTo using the z-order means that just sorting a collection of SceneObjects
	 * will result in the scene being rendered in correct z-order
	 */
	@Override
	public int compareTo(Primitive o) {
		double zOrder1 = this.getZOrder();
		double zOrder2 = o.getZOrder();
		if (zOrder1 == zOrder2) {
			return 0;
		} else {
			return (zOrder1 > zOrder2) ? -1 : 1;
		}
	}
}
