package com.blogspot.revbingo.threed;

public class Vector {

	public double dx;
	public double dy;
	public double dz;

	public Vector() {
	}

	public Vector(double dx, double dy, double dz) {
		this.dx = dx;
		this.dy = dy;
		this.dz = dz;
	}

	public double dotProduct(Vector other) {
		return this.dx * other.dx + this.dy * other.dy + this.dz * other.dz;
	}

	public Vector crossProduct(Vector other) {

		Vector v = new Vector();

		v.dx = (this.dy * other.dz) - (this.dz * other.dy);
		v.dy = (this.dz * other.dx) - (this.dx * other.dz);
		v.dz = (this.dx * other.dy) - (this.dy * other.dx);

		return v;
	}

	public Vector normalise() {
		return scale(1.0 / magnitude());
	}

	public Vector scale(double scale) {
		return new Vector(dx * scale, dy * scale, dz * scale);
	}
	
	public double magnitude() {
		return Math.sqrt(dotProduct(this));
	}
	
	public String toString() {
		return dx + "," + dy + "," + dz;
	}
}
