package com.blogspot.revbingo.threed.lights;

import java.awt.Color;

import com.blogspot.revbingo.threed.Lightable;
import com.blogspot.revbingo.threed.Point;
import com.blogspot.revbingo.threed.Vector;

public abstract class Light {

	protected Color color;
	protected Point position;
	protected Point focus;
	
	protected Vector direction;
	protected Vector lightNormal;
	
	public Color getColor() {
		return color;
	}
	
	public Point getPosition() {
		return position;
	}
	
	public void setPosition(Point p) {
		position = p;
		setDirection();
	}
	
	public Vector getDirection() {
		return direction;
	}
	
	
	public Vector getNormal() {
		return lightNormal;
	}
	
	public Point getFocus() {
		return focus;
	}

	public void setFocus(Point focus) {
		this.focus = focus;
		setDirection();
	}

	private void setDirection() {
		this.direction = position.vectorTo(focus);
		this.lightNormal = direction.normalise();
	}
	
	public abstract Color light(Lightable s);
	
}
